
Redmine - Feature #3088

Estimated hours field able to hide role based

2009-04-01 00:44 - Tim Klein

Status: New Start date: 2009-04-01

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Permissions and roles Estimated time: 0.00 hour

Target version: Candidate for next major release   

Resolution:    

Description

adding the option to hide this field to the "roles and permissions" manager

Related issues:

Related to Redmine - Feature #3976: Hide custom fields from certain roles Closed 2009-10-06

Related to Redmine - Feature #12005: Mightful workflow field enhancement: hide New

Has duplicate Redmine - Feature #3781: Add permission to control viewing of E... Closed 2009-08-25

Has duplicate Redmine - Feature #15107: Add a permission option to view estim... Closed

Has duplicate Redmine - Feature #11963: Hide the estimated times on issues fo... Closed

History

#1 - 2009-04-09 03:02 - Eric Davis

- Status changed from New to 7

- Assignee set to Eric Davis

- Estimated time deleted (0.50 h)

I've got something like this hacked onto my site right now that I can extract and cleanup a bit.

#2 - 2009-04-21 00:14 - Tim Klein

any news?

#3 - 2010-10-25 17:02 - Eric Davis

- Assignee deleted (Eric Davis)

#4 - 2011-04-20 10:58 - Anton Nepomnyaschih

+1 It would be very good to get this, as we have to hide our estimations from some roles :(

#5 - 2011-06-01 17:35 - Marc Lindsay

+1 on this one!

#6 - 2011-11-19 14:31 - Nilson Uehara

+1

#7 - 2011-11-19 23:58 - Terence Mill

is covered by #8050

#8 - 2012-01-31 14:50 - Dominique Lederer

made a plugin for this: http://www.redmine.org/plugins/redmine_hide_estimated_hours

#9 - 2012-12-03 18:46 - Pavel Bahushevich

does anybody have version 1.0.0 of this plugin?

#10 - 2013-01-13 21:04 - Jean-Philippe Lang

- Status changed from 7 to New
Assigned issue with no assignee back to New status.

#11 - 2019-01-14 05:31 - Go MAEDA

- Has duplicate Feature #3781: Add permission to control viewing of Estimated Hours based on Role added

#12 - 2019-01-14 05:32 - Go MAEDA

- Has duplicate Feature #15107: Add a permission option to view estimated hours added

#13 - 2019-01-14 13:48 - Marius BĂLTEANU

- Related to Feature #12005: Mightful workflow field enhancement: hide added

#14 - 2019-02-02 03:38 - Go MAEDA

- Has duplicate Feature #11963: Hide the estimated times on issues for certain roles added

#15 - 2019-02-02 08:19 - Bernhard Rohloff

+1 It would be great to have estimated times integrated in the allover times permissions system.

#16 - 2019-04-05 16:20 - Thierry Brochu

+1

#17 - 2019-04-26 08:13 - Yuichi HARADA

- File add_permission_view_estimated_hours.png added

- File 3088.patch added

Add "View estimated hours" permission to the "Roles and permissions".

 add_permission_view_estimated_hours.png 

If the project has the "Time tracking" module enabled and the role has "View estimated time" permission enabled, the "Estimated hours" field is

available.

I attached a patch.

#18 - 2019-08-28 16:29 - Go MAEDA

- Target version set to Candidate for next major release

#19 - 2020-01-26 05:45 - Go MAEDA

Now the patch cannot be applied cleanly.

#20 - 2020-01-30 02:46 - Yuichi HARADA

- File 3088-v2.patch added

Go MAEDA wrote:

Now the patch cannot be applied cleanly.

 Fixed the patch to work on the current trunk(r19478).

#21 - 2020-04-30 15:08 - Go MAEDA

Yuichi HARADA wrote:

Fixed the patch to work on the current trunk(r19478).

 Thank you for the patch. But I am hesitant to make this patch a candidate for 4.2.0. This is because existing users who can currently see estimated

hours will lose access to it after applying the patch because view_estimated_hours will not be granted to no roles by default.

#22 - 2022-03-16 04:00 - Go MAEDA

Go MAEDA wrote:

Yuichi HARADA wrote:

2024-05-17 2/4

https://www.redmine.org/projects/redmine/repository/svn/revisions/19478
https://www.redmine.org/projects/redmine/repository/svn/revisions/19478


Fixed the patch to work on the current trunk(r19478).

 Thank you for the patch. But I am hesitant to make this patch a candidate for 4.2.0. This is because existing users who can currently see

estimated hours will lose access to it after applying the patch because view_estimated_hours will not be granted to no roles by default.

 Adding a migration like the following will resolve the above problem.

diff --git a/db/migrate/20220315101502_add_view_estimated_hours_to_all_existing_roles.rb b/db/migrate/20220315

101502_add_view_estimated_hours_to_all_existing_roles.rb

new file mode 100644

index 000000000..ed2ad47de

--- /dev/null

+++ b/db/migrate/20220315101502_add_view_estimated_hours_to_all_existing_roles.rb

@@ -0,0 +1,9 @@

+class AddViewEstimatedHoursToAllExistingRoles < ActiveRecord::Migration[6.1]

+  def up

+    Role.all.each { |role| role.add_permission! :view_estimated_hours }

+  end

+

+  def down

+    # nothing to revert

+  end

+end

#23 - 2022-06-24 03:30 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0

#24 - 2022-07-20 08:24 - Victor C

Hi,

I've ported the patch to version 5.0.2, in case there is someone who needs it.

github.com/dotruby/redmine/pull/1

Thanks Yuichi HARADA for the patch!

#25 - 2022-07-20 13:10 - Victor C

- File 3088-v2_5.0.2.patch added

#26 - 2022-07-31 14:36 - Go MAEDA

- File 3088-v3.diff added

The patch still needs to be added some code. Even after revoking the privilege from a user, the update history of the estimated hours field is exposed

via issue journal.

#27 - 2022-08-01 06:41 - Yuichi HARADA

- File 3088-v4.patch added

Go MAEDA wrote:

The patch still needs to be added some code. Even after revoking the privilege from a user, the update history of the estimated hours field is

exposed via issue journal.

 It will be improved in the following patch.

diff --git a/app/models/journal.rb b/app/models/journal.rb

index 919a07dd2e..16a9699be4 100644

--- a/app/models/journal.rb

+++ b/app/models/journal.rb

@@ -111,6 +111,8 @@ class Journal < ActiveRecord::Base

         detail.custom_field && detail.custom_field.visible_by?(project, user)

       elsif detail.property == 'relation'

         Issue.find_by_id(detail.value || detail.old_value).try(:visible?, user)

+      elsif detail.property == 'attr' && detail.prop_key == 'estimated_hours'

+        user.allowed_to?(:view_estimated_hours, project)

       else

         true
       end

#28 - 2022-11-14 17:39 - Martin Mayr-gebhard

+1

#29 - 2023-10-15 06:59 - Mischa The Evil

- Target version changed from 5.1.0 to Candidate for next major release

While I understand the rationale behind this issue, I'd oppose to the solution proposed in the provided patches. The implementation seems

problematic for several reasons, of which some are:

this solution only covers the visibility of one specific issue attribute, while there already is a need for a more general solution covering

more/other/all attributes;

this solution mixes :time_tracking module permissions for :issue_tracking object attribute visibility;

this solution seems to make the activation of the :time_tracking module mandatory to be able to see the estimated time in issues, making it

impossible to just use the :issue_tracking module.

Given the above and the current status of 5.1.0, I'd say it's best to postpone this issue to a later version for now.

Files

add_permission_view_estimated_hours.png 50.4 KB 2019-04-26 Yuichi HARADA

3088.patch 24.7 KB 2019-04-26 Yuichi HARADA

3088-v2.patch 23.6 KB 2020-01-30 Yuichi HARADA

3088-v2_5.0.2.patch 25 KB 2022-07-20 Victor C

3088-v3.diff 23.5 KB 2022-07-31 Go MAEDA

3088-v4.patch 25.4 KB 2022-08-01 Yuichi HARADA
